from rest_framework import serializers
from phishingApp.models import *


class SignSerializer(serializers.ModelSerializer):
    class Meta:
        model = Signs
        fields = ('sign_id',
                  'text'
                  )


class TypeSerializer(serializers.ModelSerializer):
    class Meta:
        model = Types
        fields = ('type_id',
                  'type'
                  )


class EmailSerializer(serializers.ModelSerializer):
    date = serializers.DateTimeField(format="%Y-%m-%d %H:%M:%S")

    class Meta:
        model = Emails
        fields = ('email_id',
                  'subject',
                  'sender',
                  'recipient',
                  'date',
                  'cc',
                  'body',
                  'type',
                  'sign',
                  'gameruns')

    def __init__(self, *args, **kwargs):
        super(EmailSerializer, self).__init__(*args, **kwargs)
        request = self.context.get('request')
        if request and (request.method == 'POST' or request.method == 'PUT'):
            self.Meta.depth = 0
        else:
            self.Meta.depth = 1


class GameRunSerializer(serializers.ModelSerializer):
    class Meta:
        model = GameRuns
        fields = '__all__'

    def __init__(self, *args, **kwargs):
        super(GameRunSerializer, self).__init__(*args, **kwargs)
        request = self.context.get('request')
        if request and (request.method == 'POST' or request.method == 'PUT'):
            self.Meta.depth = 0
        else:
            self.Meta.depth = 1


class EmailGameRunSerializer(serializers.ModelSerializer):
    class Meta:
        model = EmailGameRuns
        fields = ('id',
                  'email',
                  'game_run',
                  'order',
                  'player_answer',
                  'duration'
                  )


class SettingSerializer(serializers.ModelSerializer):
    class Meta:
        model = Settings
        fields = ('setting_id',
                  'item',
                  'value'
                  )
